'use strict';
const { IncomingMessage } = require('http');

/**
 * Welp, here we are, already into the crazy.
 * Per documentation (https://nodejs.org/docs/latest-v12.x/api/http.html#http_request_getheader_name)
 * this should exist, yet (as of 12.18.4) it does not.  So let us change this pitch up, and patch
*/
/* istanbul ignore else */
if (typeof IncomingMessage.getHeader !== 'function') {
  IncomingMessage.prototype.getHeader = function (name) {
    if (typeof name !== 'string') {
      throw new TypeError('\'name\' must be a string');
    }
    return this.headers && this.headers[name.toLowerCase()];
  };
}
