/* eslint-disable capitalized-comments */
/* eslint-env mocha */
'use strict';

const assert = require('assert');
const { IncomingMessage } = require('http');
require('../../../lib/patches/incoming-message');

describe('IncomingMessage.getHeader', function () {
  let im;
  beforeEach(function () {
    im = new IncomingMessage();
  });
  it('requires string arg', function () {
    try {
      im.getHeader(1);
      assert.fail('did not get expected exception');
    } catch (e) {
      assert.strictEqual(e.name, 'TypeError');
    }
  });
  it('is callable', function () {
    const name = 'x-header';
    const value = undefined;
    const result = im.getHeader(name);
    assert.strictEqual(result, value);
  });
  it('returns a header', function () {
    const name = 'x-header';
    const value = 'foo';
    // eslint-disable-next-line security/detect-object-injection
    im.headers[name] = value;
    const result = im.getHeader(name);
    assert.strictEqual(result, value);
  });
});

